package flow

//
// Find a way to improve this mess, maybe it can be merged in one func
//
//

import (
	"errors"
	"fmt"
	"reflect"
	"sync"
)

type executorFunc func(OpCtx, ...Data) (Data, error)

// Operation interface
type Operation interface { // Id perhaps?
	ID() string
	Set(input Data) // Special var method
	Process(params ...Data) (Data, error)
}

// Will be named operation
type operation struct {
	sync.Mutex
	flow     *Flow
	id       string
	name     string
	kind     string
	inputs   []*operation // still figuring, might be Operation
	setter   func(Data)
	executor executorFunc
}

// OpCtx operation Context
type OpCtx = *sync.Map

// NewOpCtx creates a running context
func newOpCtx() OpCtx {
	return &sync.Map{}
}

func (o *operation) ID() string { return o.id }

func (o *operation) Process(params ...Data) (Data, error) {
	// Create CTX
	ctx := newOpCtx()
	return o.executor(ctx, params...)

	//return executeOP(o.flow, o.id, ctx, params...)
}
func (o *operation) Set(data Data) {
	if o.setter != nil {
		o.setter(data)
	}
}

// make Executor for func

// The function that executions an operation
/*func executeOP(f *Flow, id string, ctx OpCtx, params ...Data) (ret Data, err error) {
	defer func() {
		if r := recover(); r != nil {
			err = fmt.Errorf("%v", r)
			f.hooks.error(id, err)
		}
	}()

	op, ok := f.getOp(id)
	if !ok {
		err = fmt.Errorf("invalid operation '%s'", id)
		f.hooks.error(id, err)
		return nil, err
	}
		// Input param

	op.Lock()
	defer op.Unlock()
	if ctx != nil {
		if v, ok := ctx.Load(id); ok { // Cache
			return v, nil
		}
	}

	// Check inputs
	fnval := reflect.ValueOf(op.executor)
	if fnval.Type().NumIn() != len(op.inputs) {
		err = fmt.Errorf("expect %d inputs got %d", fnval.Type().NumIn(), len(op.inputs))
		f.hooks.error(id, err)
		return nil, err
	}
	/////////////////////////////
	// NEW PARALLEL PROCESSING
	///////////
	f.hooks.wait(id)

	callParam := make([]reflect.Value, len(op.inputs))

	// Parallel processing if inputs
	wg := sync.WaitGroup{}
	wg.Add(len(op.inputs))
	for i, in := range op.inputs {
		go func(i int, in *operation) {
			defer wg.Done()
			fr, err := executeOP(f, in.id, ctx, params...)
			if err != nil {
				callParam[i] = reflect.Value{}
				return
			}

			if fr == nil {
				callParam[i] = reflect.Zero(fnval.Type().In(i))
				return
			}

			callParam[i] = reflect.ValueOf(fr)
		}(i, in)
	}
	wg.Wait()
	// Return type error checking
	//
	errMsg := ""
	for i, p := range callParam {
		if !p.IsValid() {
			//callParam[i] = reflect.Zero(fnval.Type().In(i))
			errMsg += fmt.Sprintf("Input %d invalid\n", i)
		} else if !p.Type().AssignableTo(fnval.Type().In(i)) {
			errMsg += fmt.Sprintf("Input %d type mismatch expected: %v got :%v\n", i, fnval.Type().In(i), p.Type())
		}
	}
	if len(errMsg) > 0 {
		err := errors.New(errMsg)
		f.hooks.error(id, err)
		return nil, err
	}

	// The actual operation process
	f.hooks.start(id)

	fnret := fnval.Call(callParam)
	if len(fnret) > 1 && (fnret[len(fnret)-1].Interface() != nil) {
		err, ok := fnret[1].Interface().(error)
		if !ok {
			err = errors.New("unknown error")
		}
		f.hooks.error(id, err)
		return nil, err
	}

	// THE RESULT
	ret = fnret[0].Interface()
	if ctx != nil {
		ctx.Store(id, ret)
	}
	f.hooks.finish(id, ret)
	return ret, nil
}*/
func (f *Flow) makeTrigger(id string, fn executorFunc) executorFunc {
	return func(ctx OpCtx, params ...Data) (Data, error) {
		f.hooks.start(id)
		d, err := fn(ctx, params)
		if err != nil {
			f.hooks.error(id, err)
			return d, err
		}
		f.hooks.finish(id, d)
		return d, err
	}
}

func (f *Flow) makeExecutor(id string, fn interface{}) executorFunc {
	return func(ctx OpCtx, params ...Data) (Data, error) {
		var err error
		defer func() {
			if r := recover(); r != nil {
				err = fmt.Errorf("%v", r)
				f.hooks.error(id, err)
			}
		}()

		// Should not need this
		op := f.GetOp(id)
		if op == nil {
			err = fmt.Errorf("invalid operation '%s'", id)
			f.hooks.error(id, err)
			return nil, err
		}
		op.Lock()
		defer op.Unlock()
		if ctx != nil {
			if v, ok := ctx.Load(id); ok { // Cache
				return v, nil
			}
		}

		// Check inputs
		fnval := reflect.ValueOf(fn)
		if fnval.Type().NumIn() != len(op.inputs) {
			err = fmt.Errorf("expect %d inputs got %d", fnval.Type().NumIn(), len(op.inputs))
			f.hooks.error(id, err)
			return nil, err
		}
		/////////////////////////////
		// NEW PARALLEL PROCESSING
		///////////
		//f.hooks.wait(id)
		f.hooks.wait(id)

		callParam := make([]reflect.Value, len(op.inputs))
		callErrors := ""
		paramMutex := sync.Mutex{}
		// Parallel processing if inputs
		wg := sync.WaitGroup{}
		wg.Add(len(op.inputs))
		for i, in := range op.inputs {
			go func(i int, in *operation) {
				defer wg.Done()
				// Sub function with type checking
				//Check the ctx
				fr, err := in.executor(ctx, params...)
				if err != nil {
					paramMutex.Lock()
					callErrors += err.Error() + "\n"
					paramMutex.Unlock()
					return
				}
				if fr == nil {
					callParam[i] = reflect.Zero(fnval.Type().In(i))
				}
				res := reflect.ValueOf(fr)
				if !res.IsValid() {
					paramMutex.Lock()
					callErrors += fmt.Sprintf("Input %d invalid\n", i)
					paramMutex.Unlock()
					return
				} else if !res.Type().ConvertibleTo(fnval.Type().In(i)) {

					if fnval.Type().In(i).Kind() == reflect.String {
						callParam[i] = reflect.ValueOf(fmt.Sprint(res.Interface()))
						return
					}
					paramMutex.Lock()
					callErrors += fmt.Sprintf("Input %d type: %v cannot be converted to %v\n", i, res.Type(), fnval.Type().In(i))
					paramMutex.Unlock()
					return
				}
				// can convert too?

				// CheckError and safelly append
				callParam[i] = res.Convert(fnval.Type().In(i))
			}(i, in)
		}
		wg.Wait()
		// Return type error checking
		if len(callErrors) > 0 {
			err := errors.New(callErrors)
			f.hooks.error(id, err)
			return nil, err
		}

		// The actual operation process
		f.hooks.start(id)

		fnret := fnval.Call(callParam)
		if len(fnret) > 1 && (fnret[len(fnret)-1].Interface() != nil) {
			err, ok := fnret[1].Interface().(error)
			if !ok {
				err = errors.New("unknown error")
			}
			f.hooks.error(id, err)
			return nil, err
		}

		// THE RESULT
		ret := fnret[0].Interface()
		if ctx != nil {
			ctx.Store(id, ret)
		}
		f.hooks.finish(id, ret)
		return ret, nil
	}
}

// DefVar define var operation with optional initial
func (f *Flow) DefVar(id string, name string, initial ...Data) Operation {
	// Unique
	if _, ok := f.data[name]; !ok {
		var v interface{}
		if len(initial) > 0 {
			v = initial[0]
		}
		f.data[name] = v
	}
	setter := func(v Data) { f.data[name] = v }

	opEntry := &operation{
		Mutex:    sync.Mutex{},
		id:       id,
		flow:     f,
		name:     fmt.Sprintf("(var)<%s>", name),
		kind:     "var",
		inputs:   nil,
		setter:   setter,
		executor: f.makeTrigger(id, func(OpCtx, ...Data) (Data, error) { return f.data[name], nil }),
	}
	f.operations.Store(id, opEntry)
	return opEntry
}

// DefOp Manual tag an Operation
func (f *Flow) DefOp(id string, name string, params ...interface{}) (Operation, error) {
	inputs := make([]*operation, len(params))
	for i, p := range params {
		switch v := p.(type) {
		case *operation:
			inputs[i] = v
		default:
			c, err := f.Const(v)
			if err != nil {
				return nil, err
			}
			inputs[i], _ = c.(*operation)
		}
	}
	// Grab executor here
	registryFn, err := f.registry.Get(name)
	if err != nil {
		return nil, err
	}
	executor := f.makeExecutor(id, registryFn)
	op := &operation{
		Mutex:    sync.Mutex{},
		id:       id,
		flow:     f,
		name:     name,
		kind:     "func",
		inputs:   inputs,
		setter:   nil, // No set
		executor: executor,
	}
	f.operations.Store(id, op)

	return op, nil
}

// DefErrOp define a nil operation that will return error
// Usefull for builders
func (f *Flow) DefErrOp(id string, err error) (Operation, error) {
	op := &operation{
		Mutex:    sync.Mutex{},
		id:       id,
		flow:     f,
		name:     fmt.Sprintf("(error)<%v>", err),
		kind:     "error",
		inputs:   nil,
		setter:   nil,
		executor: f.makeTrigger(id, func(OpCtx, ...Data) (Data, error) { return nil, err }),
	}
	f.operations.Store(id, op)
	return op, nil
}

// DefConst define a const by defined ID
func (f *Flow) DefConst(id string, value Data) (Operation, error) {
	// Optimize this definition
	f.consts[id] = value

	op := &operation{
		id:       id,
		Mutex:    sync.Mutex{},
		flow:     f,
		name:     fmt.Sprintf("(const)<%s>", id),
		kind:     "const",
		inputs:   nil,
		setter:   nil,
		executor: f.makeTrigger(id, func(OpCtx, ...Data) (Data, error) { return f.consts[id], nil }),
	}
	f.operations.Store(id, op)

	return op, nil
}

// DefIn define input operation
func (f *Flow) DefIn(id string, paramID int) Operation {
	op := &operation{
		id:       id,
		Mutex:    sync.Mutex{},
		flow:     f,
		name:     fmt.Sprintf("(in)<%s>", id),
		kind:     "in",
		inputs:   nil,
		setter:   nil,
		executor: f.makeTrigger(id, func(ctx OpCtx, params ...Data) (Data, error) { return params[paramID], nil }),
	}
	f.operations.Store(id, op)
	return op
}
